; File:         Cnv.inc
; Author:       RuiLoureiro
; Date:         4 /Set /2001
; 

;----------------------------------------------------------------------------------------------
; Action:
;	    Converte a Dword natural em EAX em dgitos ASCII naturais
;         ( 0-9 ) que coloca na string de tipo RCL apontada por
;	    por EDI
;
; Input:
;	    EAX  	- Dword a converter em ASCII
;	    pRclStr	- Endereo da string de tipo RCL
;
; Output:
;	    clc:   N in the string
;
;	    stc:   No cabe na string => overflow ( ********** )
;
; Info:
;		Preserva todos os registos
;
DNatCnvRcl		proc  pRclStr:DWORD
			pushad
			;
			; Divide EAX por 10 e coloca no stack
			; -----------------------------------
                  mov    edi, pRclStr
			mov	 esi, 10
			call	 EAXStkCnv

			; **********************************
			; Retira do stack e coloca na string
			; ----------------------------------
			call	 RCLStkCpy
			;
                  popad
			ret
DNatCnvRcl		endp
; ---------------------------------------------------------------------------------------------
; Action:
;	  Converte a Dword hexadecimal em EAX em dgitos ASCII Hexadecimal
;       ( 0-9, A,B,C,D,E,F ) que coloca no buffer a partir de EDI
;
; Input:
;	  EAX     - Dword a converter em ASCII hexadecimal
;       pRclStr - Endereo da string
;
; Output:
;           clc: OK
;           stc:
;
DHexCnvRcl		proc	pRclStr:DWORD
			pushad
			;
                  mov     ebx, pRclStr
			cmp	  dword ptr [ebx - $RclMax$], 8
			jae	  short @F
                  ;
                  stc
			popad
			ret
			;
@@:               mov     edi, ebx
                  call	  DHexCnvBuf
			call    RCLSetLen
			;
                  popad
			ret
DHexCnvRcl		endp
; ---------------------------------------------------------------------------------------------
; Action:
;	    Converte a Dword hexadecimal em EAX em dgitos ASCII Hexadecimal
;         ( 0-9, A,B,C,D,E,F ) que coloca no buffer a partir de EDI
;
; Input:
;	    EAX  - Dword a converter em ASCII hexadecimal
;	    EDI  - buffer address
;
; Info:
;	    Deixa EDI no fim
;
DHexCnvBuf		proc
			push	  ebx
			;
			; Divide EAX by 16 and put on the stack
			; -------------------------------------
			mov	  esi, 16
			call    EAXStkCnv
			;
			; Take from stack put into buffer EDI
			; -----------------------------------
			mov     ebx, 8
			mov	  ah, 30h
			call    BufStkCpy
			;
			pop	  ebx
			ret
DHexCnvBuf		endp
; ---------------------------------------------------------------------------------------------
; Action:
;	  Converte a Dword hexadecimal em EAX em dgitos ASCII Hexadecimal
;       ( 0-9, A,B,C,D,E,F ) que coloca no buffer a partir de EDI
;
; Input:
;	  AX     - Dword a converter em ASCII hexadecimal
;       pRclStr - Endereo da string
;
; Output:
;           clc: OK
;           stc:
;
HexCnvRcl		proc	pRclStr:DWORD
			pushad
			;
                  mov     ebx, pRclStr
			cmp	  dword ptr [ebx - $RclMax$], 4
			jae	  short @F
                  ;
                  stc
			popad
			ret
			;
@@:               movzx   eax, ax
                  mov     edi, ebx
                  call	  HexCnvBuf
			call    RCLSetLen
			;
                  popad
			ret
HexCnvRcl		endp
; ---------------------------------------------------------------------------------------------
; Action:
;	    Converte a Dword hexadecimal em EAX em dgitos ASCII Hexadecimal
;         ( 0-9, A,B,C,D,E,F ) que coloca no buffer a partir de EDI
;
; Input:
;	    EAX  - Dword a converter em ASCII hexadecimal
;	    EDI  - buffer address
;
; Info:
;	    Deixa EDI no fim
;
HexCnvBuf		proc
			push	  ebx
			;
			; Divide EAX by 16 and put on the stack
			; -------------------------------------
			mov	  esi, 16
			call    EAXStkCnv
			;
			; Take from stack put into buffer EDI
			; -----------------------------------
			mov     ebx, 4
			mov	  ah, 30h
			call    BufStkCpy
			;
			pop	  ebx
			ret
HexCnvBuf		endp
; ---------------------------------------------------------------------------------------------
; Action:
;	   Divide EAX by ESI and put each ascii code on the Stack.
;        Used in conversion to binary, decimal and hexa 
;
; Input:
;	   EAX  - N a dividir
;        ESI  - N pelo qual divide
;
; Output:
;	   ECX  - N of bytes on the stack
;        ESP  - Point to the TOP of the stack where is the most significant byte (digit)
;
; Info:
;	   Destroi EAX, EDX, EBP
;
EAXStkCnv         proc	
			pop	ebp			; Remove do stack o endereo de retorno
			;
			xor	edx, edx
			xor	ecx, ecx
			;
			or	eax, eax
			jz	short _EAXStkCnv2
			;
_EAXStkCnv1:  	xor	edx, edx
			div   esi		      ; divide EDX:EAX por ESI e coloca o quociente
_EAXStkCnv2:	add   edx, 30h          ; em EAX e o resto em EDX e soma 30h
			;
			cmp	edx, 3Ah
			jb	short _EAXStkCnv3
			;
			add	edx, 7
			;
_EAXStkCnv3:	push  edx          	; to stack
			inc	ecx          	; one more
			;
			and	eax, eax
			jnz  	short _EAXStkCnv1
			;
			push	ebp               ; Restore the return address
			ret
EAXStkCnv		endp
; ---------------------------------------------------------------------------------------------
; Action:
;	    Retira do stack ECX bytes e coloca no buffer apontado por EDI
;         Sai com EDI apontando o fim do buffer e ECX n de bytes colocados
;
; Input:
;	   ECX   - N de bytes no stack
;        EDI   - Ponteiro string RCL
;
; Output:
;	   clc:    N na string
;
;	   stc:    No cabe na string => overflow ( ********** )
;
;
; Info:
;	   Usa e destroi EBX
;
RCLStkCpy         proc
			pop	 ebp                 ; Remove do stack o endereo de retorno
			;
			; Coloca 0 na string
			; ------------------
                  mov    ebx, edi
                  mov    edx, dword ptr [ebx - $RclMax$]         ; Max
			mov	 dword ptr [ebx - $RclLen$], 1           ; Len
			mov	 byte ptr [edi], '0'
			;
			; H dgitos ?
			; ------------
                  cmp    ecx, 0
			jz	 short _eRCLStkCpy
			;
			; Cabe na string ?
			; ----------------
			cmp	 ecx, edx
			jbe	 short _RCLStkCpy1					; cabe
			;
			; No cabe -> Retira os ECX bytes do stack e discard
			; ---------------------------------------------------
@@:               pop	 eax
			loop   short @B          

			; ************
			; Set OVERFLOW 
			; ------------
                  mov	 dword ptr [ebx - $RclLen$], edx
			;
			mov	 ecx, edx
			mov	 al, '*'
                  cld
			rep    stosb
			;
			stc
			push	ebp             ; Restore the return address
			ret
;.............................................................................
			; **************
			; Set the length
			; --------------
_RCLStkCpy1:      mov     dword ptr [ebx - $RclLen$], ecx
			;
			; Retira do stack e coloca no buffer RCL
			; --------------------------------------
@@:               pop	 eax
                  mov    byte ptr [edi], al
			inc    edi
			loop   short @B                  
			;
_eRCLStkCpy:	clc
                  push	ebp              ; Restore the return address
			ret
RCLStkCpy		endp
; ---------------------------------------------------------------------------------------------
; Action:
;	   Retira do stack ECX bytes e coloca no buffer apontado por EDI
;
; Input:
;	   ECX   - N de bytes no stack
;        EBX   - Comprimento mximo ( acrescenta AH no incio )
;	   AH	   - Caracter a acrescentar no incio
;        EDI   - Ponteiro inicial da string
;
; Output:
;	   EDI   - Aponta para o fim
;
BufStkCpy		proc
			pop	ebp
			;
			cld
			cmp	ecx, ebx
			jbe	short @F             
			;
			; Retira do stack ECX - EBX
			; -------------------------
			sub	ecx, ebx
			shl	ecx, 2
			add	esp, ecx
			;
			mov	ecx, ebx
			;
@@:               sub	ebx, ecx
			jz    short @F           
			;
			push	ecx
				mov	ecx, ebx
				mov	al, ah
				rep	stosb
			pop	ecx
			;
@@:               pop	eax
			stosb
			loop  short @B           
			;
			push	ebp
			ret
BufStkCpy		endp
; ---------------------------------------------------------------------------------------------

