; File:         Cursor.inc
; Author:       RuiLoureiro
; Date:         14 /04 /2005
; 
; Action:
;        Sets the COL and LIN in the variable _COLLINCur and put the cursor at that position 
;
; Input:
;       nLin  - line
;       nCol  - column
;
; Info:
;       _COLLINCur = LIN+COL dword
;
CursorSetPos        proc    nLin:DWORD, nCol:DWORD
                    pushad
                    ;
                    invoke  LCCurSet, nLin, nCol
                    invoke  SetConsoleCursorPosition, _hScreenBuffer, _COLLINCur
                    ;
                    popad
                    ret
CursorSetPos        endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Sets the nCol and nLin in the variable _COLLINCur
;
; Input:
;       nLin  - line
;       nCol  - column
;
; Info:
;       _COLLINCur = LIN+COL dword
;
LCCurSet            proc  nLin:DWORD, nCol:DWORD
                    push  ebx
                    ;
                    ;mov   ebx, offset _COLLINCur
                    mov   eax, nCol
                    mov   edx, nLin
                    dec   ax
                    dec   dx
                    mov   word ptr [_COLLINCur + 0], ax
                    mov   word ptr [_COLLINCur + 2], dx
                    ;
                    pop   ebx
                    ret
LCCurSet            endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Sets the nCol and nLin in the variable _COLLINCur
;
; Input:
;       nLin  - line
;       nCol  - column
;       Attr  - color attribute
;
; Info:
;       _COLLINCur = LIN+COL dword
;
CursorColorSet      proc nLin:DWORD, nCol:DWORD, Attr:DWORD

                    invoke   CursorSetPos, nLin, nCol
                    invoke   ColorSet, Attr

                    ret
CursorColorSet      endp
; ---------------------------------------------------------------------------------------------
CursorSetBold       proc   
                    push    ebx
                    ;
                    mov     ebx, offset _CursorInfo
                    mov     dword ptr [ebx + 0], 90                   
                    invoke   SetConsoleCursorInfo, _hScreenBuffer,
                                                   ADDR _CursorInfo
                    ;
                    pop     ebx
                    ret
CursorSetBold       endp
; ---------------------------------------------------------------------------------------------
CursorSetThin       proc   
                    push    ebx
                    ;
                    mov     ebx, offset _CursorInfo
                    mov     dword ptr [ebx + 0], 19                   
                    invoke   SetConsoleCursorInfo, _hScreenBuffer,
                                                   ADDR _CursorInfo
                    ;
                    pop     ebx
                    ret
CursorSetThin       endp
; ---------------------------------------------------------------------------------------------
CursorSetOFF        proc   
                    push    ebx
                    ;
                    mov     ebx, offset _CursorInfo
                    mov     dword ptr [ebx + 4], FALSE                   
                    invoke   SetConsoleCursorInfo, _hScreenBuffer,
                                                   ADDR _CursorInfo
                    ;
                    pop     ebx
                    ret
CursorSetOFF        endp
; ---------------------------------------------------------------------------------------------
CursorSetON         proc   
                    push    ebx
                    ;
                    mov     ebx, offset _CursorInfo
                    mov     dword ptr [ebx + 4], TRUE                   
                    invoke   SetConsoleCursorInfo, _hScreenBuffer,
                                                   ADDR _CursorInfo
                    ;
                    pop     ebx
                    ret
CursorSetON         endp
; ---------------------------------------------------------------------------------------------
CursorSave          proc   
                    pushad
                    ;
                    invoke  GetConsoleCursorInfo, _hScreenBuffer,
                                                  ADDR _CursorSaveInfo
                    ;
                    popad
                    ret
CursorSave          endp
; ---------------------------------------------------------------------------------------------
CursorReset         proc   
                    pushad
                    ;
                    invoke   SetConsoleCursorInfo, _hScreenBuffer,
                                                   ADDR _CursorSaveInfo
                    ;
                    popad
                    ret
CursorReset         endp
; 

