; File:         input.inc
; Author:       RuiLoureiro
; Date:         14 /04 /2005
; Updated:      7 / 05 /2005
; 
HndInOutGet       proc  
                  invoke   GetStdHandle, STD_INPUT_HANDLE     
	            cmp      eax, INVALID_HANDLE_VALUE	
	            je	  eStart
	            mov      _hInputBuffer, eax                 ; input buffer handle

                  invoke   GetStdHandle, STD_OUTPUT_HANDLE    
	            cmp      eax, INVALID_HANDLE_VALUE	
	            je       ibStart
	            mov      _hScreenBuffer, eax                ; screen buffer handle
                  
                  ; ----------------------
                  ; Get screen buffer info
                  ; ----------------------
                  call     InfoGet
                  ret
HndInOutGet       endp                 
; 
; The length of the RCL string goes from 0 to Max. The character position is controled by mean
; of IdxCur index (goes from 0 to IdxEnd = Max-1);
; Whenever _EditorBuffer receives one byte it is set in the palce [ _EditorBuffer+IdxCur ]
; 
; Action:
;        1- Prints RCL string pointed by pRCLStr and
;        2- Reads input buffer to it until Return
;
; Input:
;        pRCLStr - RCL string pointer 
;        nLin    - initial line
;        nCol    - initial column
;        eAttr   - color attribute in edition
;        Attr    - color attribute when exit
;
; Output:
;        clc:   exit with return       ( new string )
;
;        stc:   eax = 0  exit with ESC ( string not modified )
;                   = 1  error
;
; Uses:
;       _COLLINCur     = current cursor location
;       _hScreenBuffer = screen buffer handle
;       _hInputBuffer  = input buffer
;
RCLEditStr          proc   pRCLStr:DWORD, nLin:DWORD, nCol:DWORD, eAttr:DWORD, Attr:DWORD
                    LOCAL  IdxEnd:DWORD                         ; last    index
                    LOCAL  IdxCur:DWORD                         ; current index
                    LOCAL  InsMode:DWORD                        ; mode: Sobre\Ins
                    ;
                    push   ebx 
                    push   esi
                    push   edi
                    ;
                    call   CursorSave
                    ;
                    mov    InsMode, 0              ; mode not INS
                    call   CursorSetON
                    call   CursorSetThin
                    ;
                    ; Adjust Max Editor
                    ; -----------------
                    mov     ebx, pRCLStr
                    call    EditorMaxAdjust
                    
                    ; ----------------------------
                    ; Copy RCLStr to _EditorBuffer 
                    ; ----------------------------
                    invoke  RCLCpyRCL, ebx, ADDR _EditorBuffer
;....................................................................
;             EBX= editor pointer    EDX= current position
;....................................................................
                    ; ---------------------
                    ; Define IdxEnd, IdxCur
                    ; ---------------------
                    mov     ebx, offset _EditorBuffer
                    mov     ecx, dword ptr [ebx - 8]                ; Len
                    mov     eax, dword ptr [ebx - 4]                ; Max
                    ;
                    dec     eax
                    mov     IdxEnd, eax
                    ;
                    cmp     ecx, eax
                    jb      short @F
                    ;
                    dec     ecx
                    ;
@@:                 mov     IdxCur, ecx
                    
                    ; --------------------
                    ; Complete with spaces
                    ; --------------------
                    mov     edx, dword ptr [ebx - 4]                ; Max
                    mov     al, byte ptr _CleanChar
                    call    RCLAddFulAL
                    
                    ; --------------------
                    ; Print all RCL string
                    ; --------------------
_RCLEditStr0:       invoke  RCLPrintAll, nLin, nCol, eAttr

                    ; ----------------------------
                    ; Position Cursor in (LIN,COL)
                    ; ----------------------------
_iRCLEditStr:       mov     ecx, dword ptr [ebx - 8]          ; Len
                    mov     eax, IdxCur
                    add     eax, nCol
                    ;
                    mov     edx, IdxCur
                    call    PrintIdxCur         
                    
                    ; ---------------------------------------
                    ; Read to AL= ascii, AH=control, DX=state
                    ; ---------------------------------------
                    invoke  CharRead, nLin, eax
                    jc      _rRCLEditStr
                    ;
                    ; Key or Mouse ?
                    ; --------------
                    cmp     edi, 0
                    je      @F
                    ;
                    ; is mouse
                    ;
                    
                    jmp     _iRCLEditStr
                    ;--------------------------------------                     
@@:                 mov     edx, IdxCur
                    mov     ecx, dword ptr [ebx - 8]        ; LEN
                    mov     _FlgDoubleClick, 0

                    ;
                    ; ---------
                    ; Filter AL
                    ; ---------
                    cmp     al, 0
                    je      short _iRCLEditStr1             ; control key
                    ;
                    cmp     al, Asc_BackSpace
                    je      _exBackSpace
                    ;
                    cmp     al, Asc_Return
                    je      _oRCLEditStr                    ; exit  clc

                    cmp     al, Asc_Esc
                    je      _escRCLEditStr                  ; exit  stc

                    cmp     al, 20h
                    jb      _iRCLEditStr                    ; Begin
                    jae     _exNewChar                      ; new char
;....................................................                    
                    ; ------------
                    ; Control keys
                    ; ------------
_iRCLEditStr1:      cmp     ah, Asc_Insert                  ; insert
                    je      _exInsert
                    ;
                    cmp     ah, Asc_Esquerda                ; left
                    je      _exLeft 	
                    ;
                    cmp     ah, Asc_Direita                 ; right 
                    je      _exRight	
                    ;
                    cmp     ah, Asc_Delete                  ; delete
                    jne     short _iRCLEditStr              ; not control key
; -----------------------------------------------------------
_exDelete:          mov     ah, byte ptr _CleanChar
                    mov     al, ah
                    ;
                    dec     ecx
                    cmp     edx, ecx
                    ja      _iRCLEditStr
                    jb      short _exBackSpace2
                    ;
_exDelete1:         call    RCLPutBytAL
                    jmp    _RCLEditStr0                     ; print all
;------------------------------------------------------------
_exBackSpace:       cmp     edx, 0
                    je      _iRCLEditStr                 
                    ;
                    mov     ah, byte ptr _CleanChar
                    mov     al, ah

                    cmp     edx, ecx
                    ja      _exLeft1
                    je      short _exBackSpace1             ; ecx <> 0
                    ;
                    ; EDX < ecx
                    ; ---------
                    cmp     edx, IdxEnd
                    jne     short _exBackSpace1             ; edx not last
                    ;
                    ; edx=last => Se Last <> AH -> set AH
                    ; -----------------------------------
                    cmp     ah, byte ptr [ebx + edx]
                    jne     _exDelete1
                    ;
_exBackSpace1:      dec     edx
                    mov     IdxCur, edx
                    ;
_exBackSpace2:      call    RCLShlPos
                    jmp    _RCLEditStr0                     ; print all
;-----------------------------------------------------------------------------------------------
_exNewChar:         mov     ah, byte ptr _CleanChar
                    ;
                    cmp     InsMode, 0
                    je      short @F        
                    ;
                    cmp     ecx, 0
                    jz      short @F        
  
                    ; ------
                    ; Insert
                    ; ------
                    call     RCLShrPos
                    jc       _RCLEditStr0                       ; impossible

                    ; ------------------------------------
                    ; Puts AL into _EditorBuffer at IdxCur
                    ; ------------------------------------
@@:                 call    RCLPutBytAL
                    
                    ; --------------------
                    ; Print all RCL string
                    ; --------------------
                    invoke  RCLPrintAll, nLin, nCol, eAttr
                    jmp     _exRight                            ; Cursor right
;----------------------------------------------------------------
_exInsert:          mov     eax, InsMode
                    cmp     eax, 1
                    je      _exInsert1
                    ;

                    mov     InsMode, 1
                    call    CursorSetBold       
                    jmp     _iRCLEditStr 
                    ;
_exInsert1:         mov     InsMode, 0
                    call    CursorSetThin
                    jmp     _iRCLEditStr            
; -------------------------------------------------
_exLeft: 	        cmp     edx, 0
                    je      _iRCLEditStr                 
                    ;
_exLeft1:           dec     IdxCur
                    jmp     _iRCLEditStr
; -------------------------------------------------
_exRight:           mov     edx, IdxCur
                    cmp     edx, IdxEnd
                    je      _iRCLEditStr                 
                    ;
                    inc     IdxCur
                    jmp     _iRCLEditStr
;----------------------------------------------------------------------------------------------
_rRCLEditStr:       mov     eax, 1              ;error
                    ;                                                  
_eRCLEditStr:       stc
                    pop    edi
                    pop    esi 
                    pop    ebx
                    ret
                    ;    ESC
_escRCLEditStr:     mov     eax, 0
                    je      short _eRCLEditStr
                    ;
                    ; exit -> Copy _EditorBuffer to RCLStr
                    ; ------------------------------------
_oRCLEditStr:       invoke  RCLCpyRCL, ADDR _EditorBuffer, pRCLStr

                    mov     ebx, pRCLStr
                    invoke  RCLPrintAll, nLin, nCol, Attr
                    ;
                    call   CursorReset
                    ;
                    clc 
                    pop    edi                                                 ; OK
                    pop    esi 
                    pop    ebx
                    ret
RCLEditStr          endp
; ----------------------------------------------------------------------------------------------
; Action:
;        Reads one key from InputBuffer
;
; Input:
;        Nothing        
;
; Output:
;       clc:
;           The key was pressed:
;
;           AL  - ascii code
;           AH  - char code
;           DX  - control code
;           CX  - repetitions
;  
;       stc:    ERROR
;
; Uses:
;       _hInputBuffer  = input buffer
;
CharRead            proc    nLin:DWORD, nCol:DWORD
                    push    ebx
                    ; ---------------
                    ; Potition cursor
                    ; ---------------
_iCharRead:         invoke   KeyWait, nLin, nCol
                    jnc      short _CharRead1                     ; There is 1 InputRecord         
                    ;
                    ; mouse or error
                    ; --------------
                    cmp     eax, 0
                    jne     short @F         
                    ;
                    ;
                    stc
                    pop     ebx
                    ret
                    ;
@@:                 call    MOUSEGetEvent
                    ;
                    call    RecordMouGet 
                    call    PrintRecordsMouse
                    mov     edi, 1
                    ;
                    clc
                    pop     ebx 
                    ret
                    ;
_CharRead1:         cmp     ebx, TRUE
                    je      _CharRead2               ; key was pressed
                    ;
                    ; key was released -> Clean InputBuffer
                    ; -------------------------------------
                    invoke   PASPrint, ADDR _MsgReleased1, 4, 40, Branco_Azul
                    invoke   FlushConsoleInputBuffer, _hInputBuffer
                    jmp     _iCharRead
                    ;
                    ; Get codes
                    ; ---------
_CharRead2:         mov     ecx, eax
                    call    RecordKeyGet                            ; Get codes AL=ascii ...
                    mov     edi, 0
                    ;
                    clc
                    pop     ebx
                    ret
CharRead            endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Wait for a key 
;
; Input:
;       nothing
;
; Output:
;       clc: key event
;               EDX - Event Type
;               ECX - Number of records read
;               EBX - Pressed / Released
;               EAX - Repeat Count
;
;       stc:    ERROR
;
; Uses:
;       _hInputBuffer  = input buffer
;
; Documentation:  ReadConsoleInput ( The function does not return until at least one record is 
;                                    available to be read )
;
KeyWait             proc    nLin:DWORD, nCol:DWORD

_iKeyWait:          invoke  CursorSetPos, nLin, nCol
                    invoke  ReadConsoleInput, _hInputBuffer,          
                                              ADDR _InputBuffer,       
                                              20,                        ; read 20
                                              ADDR _InputBuffer - 8 
                    cmp      eax, 0
                    jne      @F                                          ; not error         
                    stc
                    ret
                    
                    ; ---------------------
                    ; How many read records
                    ; ---------------------
@@:                 push   esi
                        mov    esi, offset _InputBuffer
                        movzx  edx,  word ptr [esi + 0]          ; EventType
                        mov    ecx, dword ptr [esi - 8]          ; Number of records read
                        mov    ebx, dword ptr [esi + 2]          ; pressed\released
                        shr    ebx, 16
                        movzx  eax, word ptr  [esi + 6]          ; repeat count
                    pop    esi
                    ;
                    call    PrintCursor
                    call    PrintRecRead                    ; Print Number of records read
                    call    PrintKeyMouRecord
                    ;
                    cmp    ecx, 0
                    je     short _iKeyWait                  ; read 0
                    ;
                    cmp    edx, KEY_EVENT
                    jne    short @F                         ; not key
                    ;
                    clc                                     ; KEY
                    ret
                    ;
@@:                 cmp    edx, MOUSE_EVENT
                    jne    short _iKeyWait                  ; not key
                    ;
                    mov    eax, 1
                    stc                                     ; MOUSE
                    ret    
KeyWait             endp
; ---------------------------------------------------------------------------------------------
KeyOnlyWait         proc 
                    ;
                    ; Clean input buffer
                    ; ------------------
_iKeyOnlyWait:      invoke    FlushConsoleInputBuffer, _hInputBuffer
                    ;
                    invoke  ReadConsoleInput, _hInputBuffer,          
                                              ADDR _InputBuffer,       
                                              20,                        ; read 20
                                              ADDR _InputBuffer - 8 
                    cmp      eax, 0
                    jne      @F                                          ; not error         
                    stc
                    ret
                    ; ----------------------
                    ;     Key pressed ?
                    ; ----------------------
@@:                 push   esi
                        cmp    word ptr [_InputBuffer], KEY_EVENT     ; EventType
                    pop    esi
                    jne    short _iKeyOnlyWait
                    ;
                    invoke    FlushConsoleInputBuffer, _hInputBuffer
                    ret
KeyOnlyWait         endp  
; ---------------------------------------------------------------------------------------------
KeyWaitAny          proc
                    ;
                    ; Clean input buffer
                    ; ------------------
                    invoke    FlushConsoleInputBuffer, _hInputBuffer
                    invoke    KeyWait, 1, 1
                    ret
KeyWaitAny          endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Get the Input Record
;
; Input:
;        Nothing        
;
; Output:
;           AL  - ascii code
;           AH  - char code
;           DX  - control  
;           EAX - control+char code+ascii code
;
RecordKeyGet        proc
                    push    ebx 
                    ;   
                    mov     esi, offset _InputBuffer
                    movzx   edx, word ptr  [esi + 14]       ; Ascii Code
                    mov     ax,  word ptr  [esi + 12]       ; Char Code      PgUp,PgDn...
                    shl     ax, 8                           ; AH= Char code
                    mov     al, dl                          ; AL= Ascii code
                    movzx   edx,  word ptr [esi + 16]       ; ControlKeyState
                    ;
                    mov     ebx, eax
                    mov     ax, dx
                    shl     eax, 16
                    mov     ax, bx      ; EAX (high word=control) AX=Key code
                    ;
                    pop     ebx
                    ret
RecordKeyGet        endp
; ---------------------------------------------------------------------------------------------
;
;
RecordMouGet        proc    
                    push   esi

                    mov    esi, offset _InputBuffer
                    movzx  edx,  word ptr [esi + 6]          ; LIN 
                    movzx  eax,  word ptr [esi + 8]          ; ButtonClick
                    movzx  ebx,  word ptr [esi + 12]         ; KeyState

                    movzx  ecx,  word ptr [esi + 16]         ; EventFlags
                    cmp    ecx, 2
                    je     @F
                    ;
                    pop    esi
                    ret
                    ;                                 
@@:                 mov     _FlgDoubleClick, 1
                    mov     _FlgDoubleButon, ax
                    ;
                    pop    esi
                    ret
RecordMouGet        endp
; ---------------------------------------------------------------------------------------------
;
;
MOUSEGetEvent       proc    
                    push   esi
                        mov    esi, offset _InputBuffer
                        mov    edx, dword ptr [esi + 2]          ; LIN + COL
                        mov    eax, dword ptr [esi + 6]          ; ButtonState
                        mov    ebx, dword ptr [esi + 10]         ; KeyState
                        mov    ecx, dword ptr [esi + 14]         ; EventFlags
                    pop    esi
                    ret
MOUSEGetEvent       endp
; 
;                                   EDITION FUNCTIONS
; ---------------------------------------------------------------------------------------------
; Action:
;        Adjust the editor max value to the RCL string max value
;
; Input:
;       EBX     - RCL string pointer
;
; Info:
;       $MAXEDITORBUFFER = string editor max value
;
EditorMaxAdjust     proc    
                    push    ebx
                    ;
                    ; Adjust Max Editor
                    ; -----------------
                    mov     eax, dword ptr [ebx - 4]
                    ;
                    cmp     eax, $MAXEDITORBUFFER
                    jbe     @F
                    ;
                    mov     eax, $MAXEDITORBUFFER
                    ;
@@:                 mov     ebx, offset _EditorBuffer
                    mov     dword ptr [ebx - 4], eax
                    ;
                    pop     ebx
                    ret
EditorMaxAdjust     endp
; 
ColorSet            proc Atr:DWORD   
                    pushad
                    ;
                    mov      eax, Atr
                    mov     _ColorAttr, ax
                    invoke  SetConsoleTextAttribute, _hScreenBuffer, eax 
                    ;
                    popad
                    ret
ColorSet            endp
; 
; Input:
;
;
;
; Output:
;        clc:
;
;
;        stc:  error
;
;
;ENHANCED_KEY        = 0100	The key is enhanced.
;LEFT_ALT_PRESSED	   = 0002   The left ALT key is pressed.
;LEFT_CTRL_PRESSED   = 0008   The left CTRL key is pressed.
;RIGHT_ALT_PRESSED   = 0001	The right ALT key is pressed.
;RIGHT_CTRL_PRESSED  = 0004	The right CTRL key is pressed.
;SHIFT_PRESSED	   = 0010   The SHIFT key is pressed.

KeyExecCtr           proc    pTblTeclas:DWORD, pTblExecTec:DWORD, pAlt:DWORD, pWait:DWORD
                     ;
                     cmp     _ExitKeyExecCtr, 1
                     jne     @F

                     invoke  FlushConsoleInputBuffer, _hInputBuffer
                     clc
                     ret
                     ;
@@:                  mov     esi, offset _InputBuffer
                     ;
_iKeyExecCtr:        push    esi
                     ;
                     invoke  FlushConsoleInputBuffer, _hInputBuffer
                     invoke  ReadConsoleInput, _hInputBuffer,          
                                               esi,       
                                               20,                       
                                               ADDR _InputBuffer - 8 
                     cmp      eax, 0
                     jne      @F 
                     ;
                     pop      esi                                                
                     stc
                     ret
                    
                     ; ---------------------
                     ; How many read records
                     ; ---------------------
@@:                  pop    esi
                     ;
                     movzx  edx,  word ptr [esi + 0]         ; EventType
                     mov    ecx, dword ptr [esi - 8]         ; Number of records read
                     mov    ebx, dword ptr [esi + 2]         ; pressed\released
                     shr    ebx, 16
                     ;
                     cmp    ecx, 0
                     je     short _iKeyExecCtr               ; read 0
                     ;
                     cmp    edx, KEY_EVENT
                     je     short @F
                     ;
                     mov    edx, pWait
                     jmp    short _eKeyExecCtr
                     ;
@@:                  invoke    FlushConsoleInputBuffer, _hInputBuffer
                     ;
                     movzx   ecx, word ptr  [esi + 14]       ; Ascii Code
                     mov     ax,  word ptr  [esi + 12]       ; Char Code      PgUp,PgDn...
                     shl     ax, 8                           ; AH= Char code
                     mov     al, cl                          ; AL= Ascii code
                     movzx   edx,  word ptr [esi + 16]       ; ControlKeyState
                     ;
                     and      edx, LEFT_ALT_PRESSED
                     jz       short @F
                     ;
                     mov      edx, pAlt
                     jnz      short _eKeyExecCtr
                     ;
@@:                  cmp      al, 0
                     je       short @F
                     ;
                     mov      ah, al
                     ;
@@:                  invoke   TblVrfAH, pTblTeclas, pTblExecTec
                     jnc      short _eKeyExecCtr

                     mov    edx, pWait
                     ;
                     ; Return the same EBP 
                     ;
_eKeyExecCtr:        or       edx, edx
                     jz       _iKeyExecCtr
                     ;
                     leave                                  ; without leave
                     push      offset KeyExecCtr            ; _iKeyExecCtr0
                     jmp       edx
KeyExecCtr           endp
; ---------------------------------------------------------------------------------------------
; Action:
;        Verify the table TblTeclas to see if there is the key AH. If so,
;        return the proc address at the same position in the table TblExecTec with CLC.
;        Otherwise, STC.
;
; Info:
;                                                    dd Len       ; -8
;                                                    dd Max       ; -4
;       The table TblExecTec must be of the type     dd ...
;
TblVrfAH             proc   pTblTeclas:DWORD, pTblExecTec:DWORD
                     push   ebx
                     push   edi
                     ;
                     mov    edi, pTblTeclas
                     mov    ecx, dword ptr [edi - $HTbl$]
                     or     ecx, ecx
                     jz     short _TblVrfAH1
                     ;
                     xor    ebx, ebx
                     ;
_TblVrfAH0:          push   ebx
                        shl    ebx, 2
                        mov    edx, dword ptr [edi + ebx]
                        cmp    ah, dl
                     pop    ebx
                     je     short _TblVrfAH2
                     ;
                     inc    ebx
                     loop   short _TblVrfAH0
                     ;
_TblVrfAH1:          pop    edi
                     pop    ebx
                     stc
                     ret
                     ;
_TblVrfAH2:          mov    edi, pTblExecTec
                     mov    ecx, dword ptr [edi - $HTblLen$]
                     cmp    ebx, ecx
                     jae    short _TblVrfAH1
                     ;
                     shl    ebx, 2
                     mov    edx, dword ptr [edi + ebx]
                     ;
                     pop    edi
                     pop    ebx
                     clc
                     ret
TblVrfAH             endp
; 


